# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'GoogleCloudAssuredworkloadsV1WorkloadResourceSettingsResourceType',
    'WorkloadComplianceRegime',
    'WorkloadPartner',
]


class GoogleCloudAssuredworkloadsV1WorkloadResourceSettingsResourceType(str, Enum):
    """
    Indicates the type of resource. This field should be specified to correspond the id to the right resource type (CONSUMER_FOLDER or ENCRYPTION_KEYS_PROJECT)
    """
    RESOURCE_TYPE_UNSPECIFIED = "RESOURCE_TYPE_UNSPECIFIED"
    """
    Unknown resource type.
    """
    CONSUMER_PROJECT = "CONSUMER_PROJECT"
    """
    Consumer project. AssuredWorkloads Projects are no longer supported. This field will be ignored only in CreateWorkload requests. ListWorkloads and GetWorkload will continue to provide projects information. Use CONSUMER_FOLDER instead.
    """
    CONSUMER_FOLDER = "CONSUMER_FOLDER"
    """
    Consumer Folder.
    """
    ENCRYPTION_KEYS_PROJECT = "ENCRYPTION_KEYS_PROJECT"
    """
    Consumer project containing encryption keys.
    """
    KEYRING = "KEYRING"
    """
    Keyring resource that hosts encryption keys.
    """


class WorkloadComplianceRegime(str, Enum):
    """
    Required. Immutable. Compliance Regime associated with this workload.
    """
    COMPLIANCE_REGIME_UNSPECIFIED = "COMPLIANCE_REGIME_UNSPECIFIED"
    """
    Unknown compliance regime.
    """
    IL4 = "IL4"
    """
    Information protection as per DoD IL4 requirements.
    """
    CJIS = "CJIS"
    """
    Criminal Justice Information Services (CJIS) Security policies.
    """
    FEDRAMP_HIGH = "FEDRAMP_HIGH"
    """
    FedRAMP High data protection controls
    """
    FEDRAMP_MODERATE = "FEDRAMP_MODERATE"
    """
    FedRAMP Moderate data protection controls
    """
    US_REGIONAL_ACCESS = "US_REGIONAL_ACCESS"
    """
    Assured Workloads For US Regions data protection controls
    """
    HIPAA = "HIPAA"
    """
    Health Insurance Portability and Accountability Act controls
    """
    HITRUST = "HITRUST"
    """
    Health Information Trust Alliance controls
    """
    EU_REGIONS_AND_SUPPORT = "EU_REGIONS_AND_SUPPORT"
    """
    Assured Workloads For EU Regions and Support controls
    """
    CA_REGIONS_AND_SUPPORT = "CA_REGIONS_AND_SUPPORT"
    """
    Assured Workloads For Canada Regions and Support controls
    """
    ITAR = "ITAR"
    """
    International Traffic in Arms Regulations
    """
    AU_REGIONS_AND_US_SUPPORT = "AU_REGIONS_AND_US_SUPPORT"
    """
    Assured Workloads for Australia Regions and Support controls Available for public preview consumption. Don't create production workloads.
    """
    ASSURED_WORKLOADS_FOR_PARTNERS = "ASSURED_WORKLOADS_FOR_PARTNERS"
    """
    Assured Workloads for Partners
    """
    ISR_REGIONS = "ISR_REGIONS"
    """
    Assured Workloads for Israel Regions
    """
    CA_PROTECTED_B = "CA_PROTECTED_B"
    """
    Assured Workloads for Canada Protected B regime
    """


class WorkloadPartner(str, Enum):
    """
    Optional. Partner regime associated with this workload.
    """
    PARTNER_UNSPECIFIED = "PARTNER_UNSPECIFIED"
    LOCAL_CONTROLS_BY_S3NS = "LOCAL_CONTROLS_BY_S3NS"
    """
    Enum representing S3NS partner.
    """
    SOVEREIGN_CONTROLS_BY_T_SYSTEMS = "SOVEREIGN_CONTROLS_BY_T_SYSTEMS"
    """
    Enum representing T_SYSTEM partner.
    """
