# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'EntryType',
    'GoogleCloudDatacatalogV1ColumnSchemaHighestIndexingType',
    'GoogleCloudDatacatalogV1ColumnSchemaLookerColumnSpecType',
    'GoogleCloudDatacatalogV1DatabaseTableSpecDatabaseViewSpecViewType',
    'GoogleCloudDatacatalogV1DatabaseTableSpecType',
    'GoogleCloudDatacatalogV1RoutineSpecArgumentMode',
    'GoogleCloudDatacatalogV1RoutineSpecRoutineType',
    'TaxonomyActivatedPolicyTypesItem',
]


class EntryType(str, Enum):
    """
    The type of the entry. Only used for entries with types listed in the `EntryType` enum. Currently, only `FILESET` enum value is allowed. All other entries created in Data Catalog must use the `user_specified_type`.
    """
    ENTRY_TYPE_UNSPECIFIED = "ENTRY_TYPE_UNSPECIFIED"
    """
    Default unknown type.
    """
    TABLE = "TABLE"
    """
    The entry type that has a GoogleSQL schema, including logical views.
    """
    MODEL = "MODEL"
    """
    Output only. The type of models. For more information, see [Supported models in BigQuery ML] (https://cloud.google.com/bigquery-ml/docs/introduction#supported_models_in).
    """
    DATA_STREAM = "DATA_STREAM"
    """
    An entry type for streaming entries. For example, a Pub/Sub topic.
    """
    FILESET = "FILESET"
    """
    An entry type for a set of files or objects. For example, a Cloud Storage fileset.
    """
    CLUSTER = "CLUSTER"
    """
    A group of servers that work together. For example, a Kafka cluster.
    """
    DATABASE = "DATABASE"
    """
    A database.
    """
    DATA_SOURCE_CONNECTION = "DATA_SOURCE_CONNECTION"
    """
    Output only. Connection to a data source. For example, a BigQuery connection.
    """
    ROUTINE = "ROUTINE"
    """
    Output only. Routine, for example, a BigQuery routine.
    """
    LAKE = "LAKE"
    """
    A Dataplex lake.
    """
    ZONE = "ZONE"
    """
    A Dataplex zone.
    """
    SERVICE = "SERVICE"
    """
    A service, for example, a Dataproc Metastore service.
    """
    DATABASE_SCHEMA = "DATABASE_SCHEMA"
    """
    Schema within a relational database.
    """
    DASHBOARD = "DASHBOARD"
    """
    A Dashboard, for example from Looker.
    """
    EXPLORE = "EXPLORE"
    """
    A Looker Explore. For more information, see [Looker Explore API] (https://developers.looker.com/api/explorer/4.0/methods/LookmlModel/lookml_model_explore).
    """
    LOOK = "LOOK"
    """
    A Looker Look. For more information, see [Looker Look API] (https://developers.looker.com/api/explorer/4.0/methods/Look).
    """


class GoogleCloudDatacatalogV1ColumnSchemaHighestIndexingType(str, Enum):
    """
    Optional. Most important inclusion of this column.
    """
    INDEXING_TYPE_UNSPECIFIED = "INDEXING_TYPE_UNSPECIFIED"
    """
    Unspecified.
    """
    INDEXING_TYPE_NONE = "INDEXING_TYPE_NONE"
    """
    Column not a part of an index.
    """
    INDEXING_TYPE_NON_UNIQUE = "INDEXING_TYPE_NON_UNIQUE"
    """
    Column Part of non unique index.
    """
    INDEXING_TYPE_UNIQUE = "INDEXING_TYPE_UNIQUE"
    """
    Column part of unique index.
    """
    INDEXING_TYPE_PRIMARY_KEY = "INDEXING_TYPE_PRIMARY_KEY"
    """
    Column part of the primary key.
    """


class GoogleCloudDatacatalogV1ColumnSchemaLookerColumnSpecType(str, Enum):
    """
    Looker specific column type of this column.
    """
    LOOKER_COLUMN_TYPE_UNSPECIFIED = "LOOKER_COLUMN_TYPE_UNSPECIFIED"
    """
    Unspecified.
    """
    DIMENSION = "DIMENSION"
    """
    Dimension.
    """
    DIMENSION_GROUP = "DIMENSION_GROUP"
    """
    Dimension group - parent for Dimension.
    """
    FILTER = "FILTER"
    """
    Filter.
    """
    MEASURE = "MEASURE"
    """
    Measure.
    """
    PAREMETER = "PAREMETER"
    """
    Parameter.
    """


class GoogleCloudDatacatalogV1DatabaseTableSpecDatabaseViewSpecViewType(str, Enum):
    """
    Type of this view.
    """
    VIEW_TYPE_UNSPECIFIED = "VIEW_TYPE_UNSPECIFIED"
    """
    Default unknown view type.
    """
    STANDARD_VIEW = "STANDARD_VIEW"
    """
    Standard view.
    """
    MATERIALIZED_VIEW = "MATERIALIZED_VIEW"
    """
    Materialized view.
    """


class GoogleCloudDatacatalogV1DatabaseTableSpecType(str, Enum):
    """
    Type of this table.
    """
    TABLE_TYPE_UNSPECIFIED = "TABLE_TYPE_UNSPECIFIED"
    """
    Default unknown table type.
    """
    NATIVE = "NATIVE"
    """
    Native table.
    """
    EXTERNAL = "EXTERNAL"
    """
    External table.
    """


class GoogleCloudDatacatalogV1RoutineSpecArgumentMode(str, Enum):
    """
    Specifies whether the argument is input or output.
    """
    MODE_UNSPECIFIED = "MODE_UNSPECIFIED"
    """
    Unspecified mode.
    """
    IN_ = "IN"
    """
    The argument is input-only.
    """
    OUT = "OUT"
    """
    The argument is output-only.
    """
    INOUT = "INOUT"
    """
    The argument is both an input and an output.
    """


class GoogleCloudDatacatalogV1RoutineSpecRoutineType(str, Enum):
    """
    The type of the routine.
    """
    ROUTINE_TYPE_UNSPECIFIED = "ROUTINE_TYPE_UNSPECIFIED"
    """
    Unspecified type.
    """
    SCALAR_FUNCTION = "SCALAR_FUNCTION"
    """
    Non-builtin permanent scalar function.
    """
    PROCEDURE = "PROCEDURE"
    """
    Stored procedure.
    """


class TaxonomyActivatedPolicyTypesItem(str, Enum):
    POLICY_TYPE_UNSPECIFIED = "POLICY_TYPE_UNSPECIFIED"
    """
    Unspecified policy type.
    """
    FINE_GRAINED_ACCESS_CONTROL = "FINE_GRAINED_ACCESS_CONTROL"
    """
    Fine-grained access control policy that enables access control on tagged sub-resources.
    """
