# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'ControlSearchSolutionUseCaseItem',
    'ControlSolutionTypesItem',
    'GoogleCloudRetailV2alphaSearchRequestDynamicFacetSpecMode',
    'GoogleCloudRetailV2alphaSearchRequestPersonalizationSpecMode',
    'ProductAvailability',
    'ProductType',
    'ServingConfigDiversityType',
    'ServingConfigSolutionTypesItem',
]


class ControlSearchSolutionUseCaseItem(str, Enum):
    SEARCH_SOLUTION_USE_CASE_UNSPECIFIED = "SEARCH_SOLUTION_USE_CASE_UNSPECIFIED"
    """
    The value when it's unspecified. In this case, server behavior defaults to SEARCH_SOLUTION_USE_CASE_SEARCH.
    """
    SEARCH_SOLUTION_USE_CASE_SEARCH = "SEARCH_SOLUTION_USE_CASE_SEARCH"
    """
    Search use case. Expects the traffic has a non-empty query.
    """
    SEARCH_SOLUTION_USE_CASE_BROWSE = "SEARCH_SOLUTION_USE_CASE_BROWSE"
    """
    Browse use case. Expects the traffic has an empty query.
    """


class ControlSolutionTypesItem(str, Enum):
    SOLUTION_TYPE_UNSPECIFIED = "SOLUTION_TYPE_UNSPECIFIED"
    """
    Default value.
    """
    SOLUTION_TYPE_RECOMMENDATION = "SOLUTION_TYPE_RECOMMENDATION"
    """
    Used for Recommendations AI.
    """
    SOLUTION_TYPE_SEARCH = "SOLUTION_TYPE_SEARCH"
    """
    Used for Retail Search.
    """


class GoogleCloudRetailV2alphaSearchRequestDynamicFacetSpecMode(str, Enum):
    """
    Mode of the DynamicFacet feature. Defaults to Mode.DISABLED if it's unset.
    """
    MODE_UNSPECIFIED = "MODE_UNSPECIFIED"
    """
    Default value.
    """
    DISABLED = "DISABLED"
    """
    Disable Dynamic Facet.
    """
    ENABLED = "ENABLED"
    """
    Automatic mode built by Google Retail Search.
    """


class GoogleCloudRetailV2alphaSearchRequestPersonalizationSpecMode(str, Enum):
    """
    Defaults to Mode.AUTO.
    """
    MODE_UNSPECIFIED = "MODE_UNSPECIFIED"
    """
    Default value. In this case, server behavior defaults to Mode.AUTO.
    """
    AUTO = "AUTO"
    """
    Let CRS decide whether to use personalization based on quality of user event data.
    """
    DISABLED = "DISABLED"
    """
    Disable personalization.
    """


class ProductAvailability(str, Enum):
    """
    The online availability of the Product. Default to Availability.IN_STOCK. Corresponding properties: Google Merchant Center property [availability](https://support.google.com/merchants/answer/6324448). Schema.org property [Offer.availability](https://schema.org/availability).
    """
    AVAILABILITY_UNSPECIFIED = "AVAILABILITY_UNSPECIFIED"
    """
    Default product availability. Default to Availability.IN_STOCK if unset.
    """
    IN_STOCK = "IN_STOCK"
    """
    Product in stock.
    """
    OUT_OF_STOCK = "OUT_OF_STOCK"
    """
    Product out of stock.
    """
    PREORDER = "PREORDER"
    """
    Product that is in pre-order state.
    """
    BACKORDER = "BACKORDER"
    """
    Product that is back-ordered (i.e. temporarily out of stock).
    """


class ProductType(str, Enum):
    """
    Immutable. The type of the product. Default to Catalog.product_level_config.ingestion_product_type if unset.
    """
    TYPE_UNSPECIFIED = "TYPE_UNSPECIFIED"
    """
    Default value. Default to Catalog.product_level_config.ingestion_product_type if unset.
    """
    PRIMARY = "PRIMARY"
    """
    The primary type. As the primary unit for predicting, indexing and search serving, a Type.PRIMARY Product is grouped with multiple Type.VARIANT Products.
    """
    VARIANT = "VARIANT"
    """
    The variant type. Type.VARIANT Products usually share some common attributes on the same Type.PRIMARY Products, but they have variant attributes like different colors, sizes and prices, etc.
    """
    COLLECTION = "COLLECTION"
    """
    The collection type. Collection products are bundled Type.PRIMARY Products or Type.VARIANT Products that are sold together, such as a jewelry set with necklaces, earrings and rings, etc.
    """


class ServingConfigDiversityType(str, Enum):
    """
    What kind of diversity to use - data driven or rule based. If unset, the server behavior defaults to RULE_BASED_DIVERSITY.
    """
    DIVERSITY_TYPE_UNSPECIFIED = "DIVERSITY_TYPE_UNSPECIFIED"
    """
    Default value.
    """
    RULE_BASED_DIVERSITY = "RULE_BASED_DIVERSITY"
    """
    Rule based diversity.
    """
    DATA_DRIVEN_DIVERSITY = "DATA_DRIVEN_DIVERSITY"
    """
    Data driven diversity.
    """


class ServingConfigSolutionTypesItem(str, Enum):
    SOLUTION_TYPE_UNSPECIFIED = "SOLUTION_TYPE_UNSPECIFIED"
    """
    Default value.
    """
    SOLUTION_TYPE_RECOMMENDATION = "SOLUTION_TYPE_RECOMMENDATION"
    """
    Used for Recommendations AI.
    """
    SOLUTION_TYPE_SEARCH = "SOLUTION_TYPE_SEARCH"
    """
    Used for Retail Search.
    """
